<?php
/** FileHandler class 
 * 
 * Opens a file in the constructor, writes in it and closes it in the destructor
 *
 * @author Claire Figueras <dev@maarch.org>
 **/
class FileHandler
{
	/** 
	 * Open database connexion
     *
     * @protected
     **/
	protected $conn;
    
	/** 
	 * Log table name
     *
     * @protected
     **/
	protected $log_table;
    
    protected $details_log = false;
    
    protected $nb_errors = 0;
	
	/** Class constructor
     * 
	 * @param $db_conn (Object) database connexion
     **/
	function __construct($db_conn, $tablename)
	{
		$this->conn = $db_conn;	
		$this->log_table = $tablename;	
	}
	
	/** Writes in database
     *
	 * @param $msg (string) Log message
	 * @param $error_level (string) Error level
	 * @param $error_code (integer) Error code
     **/
	function write($msg, $error_level, $error_code, $other_params)
	{
        $fields = "(";
        $values = "(";
        foreach(array_keys($other_params['values_table']) as $key)
        {
            $fields .= $key.',';
            if($other_params['values_table'][$key]['type'] == 'string' || $other_params['values_table'][$key]['type'] == 'date')
            {
                $values .= "'".$other_params['values_table'][$key]['value']."',";
            }
            else
            {
                 $values .= $other_params['values_table'][$key]['value'].",";
            }
        }
        $values = preg_replace("/,$", ")", $values);
        $fields = preg_replace("/,$", ")", $fields);
        
        $req = "insert into ".$this->log_table." ".$fields.' values '.$values;
        
        $this->$conn->query($req);
	}
	
	/** Class destructor
     *
     * Closes the database connexion
     **/
	function __destruct()
	{
		$this->$conn->disconnect();
	}
}
?>
